#!/usr/local/bin/perl
#
# Wiki - ɵWiki
#
# Copyright (c) 2004 Satoshi Fukutomi <fuktommy@inter7.jp>
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. Neither the name of the University nor the names of its contributors
#    may be used to endorse or promote products derived from this software
#    without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: tsuwiki.cgi,v 1.10 2004/08/11 12:27:41 fuktommy Exp $
#

use lib qw(.);
use strict;
use TsuWiki;

#
# 
#
my $CSS_URI		= "tsuwiki.css";
my $LICENCE_RDF		= "licence.rdf";
my $LICENCE_IMG		= "src='somerights20.gif' width='88' height='31'";
my $LICENCE_URI		= "http://creativecommons.org/licenses/by/2.0/jp/";
my $LICENCE		= "ꥨƥ֡󥺡饤";
my $SELF_URI		= "http://example.com/tsuwiki.cgi";	# WikiURI(URI)
my $GOOGLE_URI		= "http://www.google.co.jp/search";
my $TITLE		= "Wiki";				# WikiΤΥȥ
my $DESCRIPTION		= "ɵWikiǤ";			# Ȥδñ
my $MAIL_ADDRESS	= 'fuktommy@inter7.jp';			# ʤΥ᡼륢ɥ쥹
$TsuWiki::DATA_DIR	= "./data";				# ǡ񤭹Ȥ
$TsuWiki::SAVE_HISTORY	= 10;					# Խ򲿸Ĥޤ¸뤫
$TsuWiki::ART_LIMIT	= 10240;				# 񤭹ߤκ祵(Bytes)
umask 0000;

#
# å
#
my %message = (
	new	=> "",
	index	=> "",
	changes	=> "",
	search	=> "",
	help	=> "إ",
	rss	=> "RSS",
	history	=> "",
	add	=> "ɵ",
	edit	=> "Խ",
	view	=> "ɸ",
	error	=> "顼",
	google	=> "Google",
	licence => "work<a rel='license' href='$LICENCE_URI'>$LICENCE</a>βǥ饤󥹤Ƥޤ",
);

#
# 
#
sub xlocaltime($) {
	my @buf = localtime($_[0]);
	return sprintf "%d/%02d/%02d %02d:%02d",
		       1900+$buf[5], $buf[4]+1, $buf[3], $buf[2], $buf[1];
}
sub rfc822_time($) {
	my @buf  = gmtime($_[0]);
	my @wday = qw(Sun Mon Tue Wed Thu Fri Sat);
	my @mon	 = qw(Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec);
	return sprintf "%s, %02d %s %d %02d:%02d:%02d GMT",
		       $wday[$buf[6]], $buf[3], $mon[$buf[4]], 1900+$buf[5], $buf[3], $buf[2], $buf[1];
}

#
# إåȤ
# $opt{deny_robot}, $opt{normal_page}
#
sub printHeader($;%) {
	my($title, %opt) = @_;
	my $str_title = str_encode($title);
	print "Content-Type: text/html; charset=EUC-JP\r\n",
	      "\r\n",
	      '<?xml version="1.0" encoding="EUC-JP"?>',
	      '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN"',
	      ' "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">',
	      "<html xmlns='http://www.w3.org/1999/xhtml' xml:lang='ja'>",
	      '<head>',
	      "<meta http-equiv='Content-Language' content='ja' />",
#	      "<meta http-equiv='Content-Style-Type' content='text/css' />",
	      '<meta http-equiv="Content-Type" content="text/html; charset=EUC-JP" />';
	print "<meta name='robots' content='NOINDEX,NOFOLLOW' />" if ($opt{deny_robot});
	print "<title>$title - $TITLE</title>",
	      "<link rev='made' href='mailto:$MAIL_ADDRESS' />",
	      "<link rel='contents' href='$SELF_URI' />",
	      "<link rel='index' href='$SELF_URI?cmd=index' />",
	      "<link rel='stylesheet' type='text/css' href='$CSS_URI' />",
	      "<link rel='alternate' type='application/rss+xml' title='rss' href='$SELF_URI?cmd=rss' />",
	      "<link rel='meta' href='$LICENCE_RDF' />",
#	      "<link rel='shortcut icon' href='/favicon.ico' />",
	      "</head>",
	      "<body><p class='header'>",
	      "<a href='$SELF_URI?cmd=new'>$message{new}</a> | ",
	      "<a href='$SELF_URI?cmd=index'>$message{index}</a> | ",
	      "<a href='$SELF_URI?cmd=changes'>$message{changes}</a> | ",
	      "<a href='$SELF_URI?cmd=search'>$message{search}</a> | ",
	      "<a href='$SELF_URI?cmd=rss'>$message{rss}</a> | ";
	print "<a href='$SELF_URI?$str_title'>$message{view}</a> | ",
	      "<a href='$SELF_URI?cmd=edit&amp;msg=$str_title'>$message{edit}</a> | ",
	      "<a href='$SELF_URI?cmd=history&amp;msg=$str_title'>$message{history}</a> | "
	      if ($opt{normal_page});
	print "<a href='$SELF_URI?cmd=help'>$message{help}</a>",
	      "</p>",
	      "<h1><a href='$SELF_URI?cmd=search&amp;msg=$str_title' class='title' title='$message{search}'>$title</a></h1>";
}

#
# 
#
sub print302($) {
	my($next) = @_;
	print "Content-Type: text/html; charset=EUC-JP\r\n",
	      "\r\n",
	      '<?xml version="1.0" encoding="EUC-JP"?>',
	      '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN"',
	      ' "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">',
	      '<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja">',
	      '<head>',
	      '<meta http-equiv="Content-Language" content="ja" />',
	      '<meta http-equiv="Content-Type" content="text/html; charset=EUC-JP" />',
	      '<meta http-equiv="Content-Script-Type" content="text/javascript" />',
	      "<title>moved</title>",
	      "<link rev='made' href='mailto:$MAIL_ADDRESS' />",
	      "<link rel='contents' href='$SELF_URI' />",
	      "</head>",
	      "<body><p>Click and jump to <a href='$next'>$next</a></p>\n",
	      "<script type='text/javascript'>window.location.href = '$next';</script>",
	      "</body></html>\n";
}

#
# HTMLؤѷ
#
sub html_format($) {
	local($_) = @_;
	s|<br>|<br />|g;
	s|https?://[^\x00-\x20"'()<>\[\]\x7F-\xFF]{2,}|<a href='$&'>$&</a>|g;
	s|\[\[<a.*?>(.*?)\]\]</a>|[[$1]]|g;
	s|\[\[([^<>]+?)\]\]|sprintf("<a href='%s?%s'>[[%s]]</a>",$SELF_URI,str_encode($1),$1)|eg;
	return $_;
}

#
# ꥹȤǤؤѷ
#
sub list_format(@) {
	my @buf = ();
	local $_;
	foreach (@_) {
		push @buf, "<li>" . xlocaltime(stamp($_)) .  " <a href='$SELF_URI?" .
		      str_encode($_) . "'>$_</a></li>\n";
	}
	return @buf;
}

#
# 
#
sub newPageForm() {
	print "<form method='get' action='$SELF_URI'><p>",
	      "<input name='msg' size='30' value='' tabindex='1' accesskey='t' />",
	      "<input type='hidden' name='cmd' value='view' />",
	      "<input type='submit' value='$message{new}' name='submit' tabindex='2' accesskey='w' />",
	      "</p></form>";
}

#
# ɵ
# $opt{page}
#
sub addForm(%) {
	my %opt = @_;
	my $page = str_encode($opt{page});

	print "<form method='post' action='$SELF_URI?cmd=add&amp;msg=$page'><p>",
	      "<input type='submit' value='$message{add}' name='submit' tabindex='1' accesskey='w' /><br />",
	      "<textarea rows='10' cols='70' name='body' tabindex='8' accesskey='c'></textarea>",
	      "</p></form>";
}

#
# Խ
# $opt{page}, $opt{base}, $opt{body}
#
sub editForm(%) {
	my %opt = @_;
	my $page = str_encode($opt{page});
	my $body = unescape($opt{body});
	print "<form method='post' action='$SELF_URI?cmd=post&amp;msg=$page'><p>",
	      "<input type='hidden' value='$opt{base}' name='base' />",
	      "<input type='submit' value='$message{edit}' name='submit' tabindex='1' accesskey='w' /><br />",
	      "<textarea rows='15' cols='80' name='body' tabindex='8' accesskey='c'>$body</textarea>",
	      "</p></form>";
}

#
# ̤Υڡɽ
#
sub printPage($) {
	my($file) = @_;
	my @buf = readFile($file);
	printHeader($file, normal_page=>1);
	my $body = "";
	if (@buf) {
		my %buf = rec($buf[-1]);
		$body = html_format($buf{body});
	}
	print "\n<p>$body</p>\n";
	addForm(page=>$file);
	print "<p><a rel='licence' href='$LICENCE_URI'><img alt='$LICENCE' $LICENCE_IMG /></a><br />",
	      "$message{licence}</p></body></html>\n";
}

#
# ⡼ɤɽ
#
sub printHistoryPage($) {
	my($file) = @_;
	my @buf = readFile($file);
	printHeader($file, normal_page=>1, deny_robot=>1);
	print "<dl>\n";
	local $_;
	foreach (@buf) {
		my %rec = rec($_);
		print "<dt>", xlocaltime($rec{stamp}), "</dt><dd>", html_format($rec{body}), "<br /><br /><br /></dd>\n";
	}
	print "</dl>";
	my $body = "";
	my $base = "";
	if (@buf) {
		my %buf = rec($buf[-1]);
		$body = $buf{body};
		$base = $buf{stamp};
		setStamp($file, $buf{stamp});
	}
	editForm(page=>$file, base=>$base, body=>$body);
	print "</body></html>\n";
}

#
# Խ⡼ɤɽ
#
sub printEditPage($) {
	my($file) = @_;
	my @buf = readFile($file);
	printHeader($file, normal_page=>1, deny_robot=>1);
	my $body = "";
	my $base = "";
	if (@buf) {
		my %buf = rec($buf[-1]);
		$body = $buf{body};
		$base = $buf{stamp}
	}
	print "\n<p>", html_format($body), "</p>\n";
	editForm(page=>$file, base=>$base, body=>$body);
	print "</body></html>\n";
}

#
# 顼
#
sub printError($) {
	my($msg) = $_[0];
	printHeader($message{error}, deny_robot=>1);
	print "<p>$message{error}: $msg</p>",
	      "</body></html>\n";
}

#
# 
#
sub printIndexPage() {
	printHeader($message{index});
	print "<ul>\n";
	my @buf = list();
	@buf = sort @buf;
	@buf = list_format(@buf);
	print @buf;
	print "</ul>";
	newPageForm();
	print "</body></html>\n";
}

#
# 
#
sub printChangesPage() {
	printHeader($message{changes});
	print "<ul>\n";
	my @buf = list();
	@buf = list_format(@buf);
	@buf = sort {$b cmp $a} @buf;
	print @buf;
	print "</ul>";
	newPageForm();
	print "</body></html>\n";
}

#
# RSS
#
sub printRssPage() {
	print "Content-Type: text/xml; charset=EUC-JP\r\n",
	      "\r\n",
	      "<?xml version='1.0' encoding='EUC-JP'?>",
	      "<rss version='2.0'>",
	      "<channel>",
	      "<title>$TITLE</title>",
	      "<link>$SELF_URI</link>",
	      "<description>$DESCRIPTION</description>",
	      "<language>ja-jp</language>",
	      "\n";
	my $f;
	foreach $f (list()) {
		my $s = rfc822_time(stamp($f));
		print "<item><title>$f</title>",
		      "<link>$SELF_URI?", str_encode($f), "</link>",
		      "<pubDate>$s</pubDate>",
		      "</item>\n";
	}
	print "</channel></rss>\n";
}

#
# ե
# $arg{query}
#
sub searchForm(%) {
	my %opt = @_;
	my $query = (defined $opt{query})? $opt{query}: "";
	my $xquery = escapeValue($query);
	print "<form method='get' action='$SELF_URI'><p>",
	      "<input name='cmd' type='hidden' value='search' />",
	      "<input name='msg' size='19' value=\"$xquery\" tabindex='1' accesskey='q' />",
	      "<input type='submit' value='$message{search}' name='submit' tabindex='2' accesskey='s' />",
	      "</p></form>";

	my $gquery = $query;
#	$gquery =~ s/\|/ OR /g;
#	$gquery =~ s/\.[+*]?/ /g;
	$gquery = escapeValue($gquery);
	print "<form method='get' action='$GOOGLE_URI'><p>",
	      "<input name='q' size='19' value=\"$gquery\" tabindex='1' accesskey='g' />",
	      "<input type='hidden' name='ie' value='EUC-JP' />",
	      "<input type='submit' name='google' value='$message{google}' tabindex='1' accesskey='g' />",
	      "</p></form>";
}

#
# 
#
sub printSearchPage() {
	printHeader($message{search});
	searchForm();
	print "</body></html>\n";
}

#
# 
#
sub printSearchResultPage($) {
	my($query) = @_;
	printHeader($message{search});
	print "<ul>\n";
	my @buf = search($query);
	@buf = list_format(@buf);
	@buf = sort {$b cmp $a} @buf;
	print @buf;
	print "</ul>";
	searchForm(query=>$query);
	print "</body></html>\n";
}

#
# إ
#
sub printHelpPage() {
	printHeader($message{help});
	my $buf = "֤WikiפɵWikiǤ\n" .
		  "ɵץܥ򲡤ƵڤɵƤ\n" .
		  "̤ԽǤޤ\n" .
		  "\n" .
		  "[[ڡ]]ȤWiki󥯤ˤʤޤ\n" .
		  "http://www.google.co.jp/Ȥȥ󥯤ˤʤޤ\n" .
		  "ԤϤΤޤɽޤ\n" .
		  "ΤۤWikiˡϻȤޤ\n" .
		  "\n" .
		  "ڡκϱޥɤǤ\n" .
		  "\n" .
		  "ΡYukiWikiסΤ顣פ򻲹ͤˤޤ" .
		  "http://www.hyuki.com/\n" .
		  "(Fuktommy)Υڡhttp://fuktommy.s64.xrea.com/\n";
	$buf = html_format(escape($buf));
	print "<p>$buf</p></body></html>\n";
}

#
# ƤΥǡɽ(Хåå)
#
sub printAllData() {
	print "Content-Type: text/plain; charset=EUC-JP\r\n",
	      "\r\n";
	my $f;
	foreach $f (list()) {
		my $d;
		foreach $d (readFile($f)) {
			my %rec = rec($d);
			print "$f<>$rec{stamp}<>$rec{body}\n";
		}
	}
}

#
# ᥤ
#
if (-d $TsuWiki::DATA_DIR) {
	# ok
} elsif (mkdir $TsuWiki::DATA_DIR, 0777) {
	# ok
} else {
	printError($TsuWiki::DATA_DIR);
	exit;
}

my $input;
if ($ENV{REQUEST_METHOD} eq "POST") {
	read(STDIN, $input, $ENV{CONTENT_LENGTH});
	$input .= "&$ENV{QUERY_STRING}";
} else {
	$input = $ENV{QUERY_STRING};
	}
my %arg = args($input);

if ((! defined $arg{cmd})||($arg{cmd} eq "")) {
	printChangesPage();

} elsif ($arg{cmd} eq "index") {
	printIndexPage();

} elsif ($arg{cmd} eq "changes") {
	printChangesPage();

} elsif ($arg{cmd} eq "rss") {
	printRssPage();

} elsif ($arg{cmd} eq "help") {
	printHelpPage();

} elsif ($arg{cmd} eq "all") {
	printAllData();

} elsif (($arg{cmd} eq "view") && (defined $arg{msg}) && ($arg{msg} ne "")) {
	printPage($arg{msg});

} elsif (($arg{cmd} eq "edit") && (defined $arg{msg}) && ($arg{msg} ne "")) {
	printEditPage($arg{msg});

} elsif (($arg{cmd} eq "history") && (defined $arg{msg}) && ($arg{msg} ne "")) {
	printHistoryPage($arg{msg});

} elsif ($arg{cmd} eq "new") {
	printHeader($message{new}, denu_robot=>1, );
	newPageForm();
	print "</body></html>\n";

} elsif (($arg{cmd} eq "add") && (defined $arg{msg}) && ($arg{msg} ne "")) {
	if (! ((defined $arg{body}) && ($arg{body} ne ""))) {
		printError($arg{msg});
	} elsif (margeRecord($arg{msg}, $arg{body})) {
		print302("$SELF_URI?" . str_encode($arg{msg}));
	} else {
		printError($arg{msg});
	}

} elsif (($arg{cmd} eq "post") && (defined $arg{msg}) && ($arg{msg} ne "")) {
	if (addRecord($arg{msg}, $arg{body}, $arg{base})) {
		print302("$SELF_URI?" . str_encode($arg{msg}));
	} else {
		printError($arg{msg});
	}

} elsif (($arg{cmd} eq "search") && (defined $arg{msg}) && ($arg{msg} ne "")) {
	printSearchResultPage($arg{msg});

} elsif ($arg{cmd} eq "search") {
	printSearchPage();

} else {
	printIndexPage();
}

